; TIP951.LSP:  FIN.LSP   Parametric Fin Tubes   $50 BONUS WINNER
;                               (c)1994, Michael P. Kavanagh

(defun *error* (msg / )
   (princ "You have an error: ")
   (princ msg)
   (princ)
   (END_FUNC)
)
(prompt "\nL O A D I N G   F I N T U B E   P R O G R A M ")
;;
;;========================= MAIN PROGRAM =================
;;
(defun C:FIN (/ p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 a b ang lr dist disf ftn
   elf eli yn l1 l2 l3 l4 enf eni ei efo ef elfi btuh mbh ip)
   ;june 18, 1993 by MPK
   (START_FUNC) ;save default settings 
   (command ".layer" "m" "hvpipe" "c" "3" "" "")
   (setvar "osmode" 0)
   (setvar "orthomode" 1)
   (setq p1 (getpoint "\nPick left corner of fintube: ")
      p2 (getpoint p1 "\nPick right corner or fintube: ")
      dist (distance p1 p2)
      disf (/ dist 12.0)
      ang (angle p1 p2)
      p3 (polar p1 (- ang (dtr 90)) 6) 
      p4 (polar p2 (- ang (dtr 90)) 6)
   )                                               
   (initget 1 "L R")
   (setq lr (getkword "\nControl valve to be installed on <L>eft or <R>ight of fintube: "))
   (if (= lr "R")      
      (progn           
         (setq p5 (polar p1 ang 9)
            p6 (polar p3 ang 9)
            p7 (polar p1 ang (- dist 3))
            p8 (polar p3 ang (- dist 3))
            p9 (polar p1 ang (- dist 15))
            p10 (polar p3 ang (- dist 15))
         )
         (command ".pline" p1 "w" "0" "0" p9 p10 p3 "c")
         (command ".pline" p2 "w" "0" "0" p7 p8 p4 "c")
         (command ".line" p5 p6 "")
         (command ".line" (osnap p5 "midp") (osnap p9 "midp") "")
      )
      (progn                              
         (setq p5 (polar p1 ang (- dist 9))
            p6 (polar p3 ang (- dist 9))
            p7 (polar p1 ang 15)
            p8 (polar p3 ang 15)
            p9 (polar p1 ang 3)
            p10 (polar p3 ang 3)
         )
         (command ".pline" p1 "w" "0" "0" p9 p10 p3 "c")
         (command ".pline" p2 "w" "0" "0" p7 p8 p4 "c")
         (command ".line" p5 p6 "")
         (command ".line" (osnap p5 "midp") (osnap p7 "midp") "")
      )
   )
   (setq ins (inters p7 p10 p8 p9))
   (command ".insert" "cvalve" ins "" "" (- (rtd ang) 180))
   (prompt "\nPick t-stat location: ")
   (command ".insert" "STAT" pause "" "" "")   
   (setq a (entget (entlast))
      b (cdr (assoc 10 a))
   )
   (command ".text" "j" "m" b "" "" "T")
   (setvar "osmode" 16)
   (setvar "orthomode" 0)
   (prompt "\nPick points on t-stat and valve for arc: ")
   (command ".arc" pause "e" pause "d" pause) 
   (command ".change" "last" b "" "p" "c" "7" "")
   (setvar "osmode" 0)
   (command ".layer" "m" "hvtext" "")
   (setq ftn (getint "\nEnter fintube number: ")
      elf (getint "\nEnter element feet: ")
      eli (getint "\nEnter element inches: <0> ")
   )
   (if (= eli nil)
      (setq eli 0)
   )
   (initget 1 "Y N")
   (setq yn (getkword "\nDoes enclosure run from wall to wall <Y>es or <N>o: "))
   (if (= yn "Y")
      (progn
         (while (<= disf elf)
            (setq elf (getint "\nThe element will not fit in the enclosure, please enter a smaller element length: "))
         )
         (setq l3 (strcat "W TO W ENCL."))
      )
      (progn
         (setq enf (getint "\nEnter enclosure feet: "))
         (while (<= enf elf)
            (setq enf (getint "\nThe element will not fit in the enclosure, please enter a larger enclosure length: "))
         )
         (setq eni (getint "\nEnter enclosure inches: <0> "))
         (if (= eni nil)
            (setq eni 0)
         )
         (setq l3 (strcat (itoa enf)(chr 39)"-"(itoa eni)(chr 34) " ENCL."))
      )
   )
   (if (/= eli 0)
      (setq ei 0.5)
      (setq ei 0.0)
   )
   (setq efo (itoa elf)
      ef (atof efo)
   )
   (setq elfi (+ ef ei))
   (setq btuh (getreal "\nEnter fintube BTUH per foot: "))
   (setq mbh (* elfi (/ btuh 1000.0)))
   (setq l1 (strcat "%%uFT-"(itoa ftn))
      l2 (strcat (itoa elf)(chr 39)"-"(itoa eli)(chr 34) " ELEM.")
      L4 (strcat "1 GPM, "(rtos mbh 2 1) " MBH")
   )
   (setq ip (getpoint "\nSelect location of text: "))
   (command ".text" ip "0" l1 "") ;;written for fixed height text
   (command ".text" "" l2 "")
   (command ".text" "" l3 "")
   (command ".text" "" l4 "")
   (lead1)
   (END_FUNC)
   (princ)
)
(prompt "\nFintube program loaded")
(prompt "\nType FIN at autoCAD command prompt:")
(princ)
;;
;======================== LEADER PROGRAM =================
;;
(defun LEAD1 (/ pt1 pt2 pt3 pt4 ang rot)
   (setvar "orthomode" 1)
   (setvar "snapmode" 0)
   (setq pt1 (getpoint "\nPick first point of leader: "))
   (setq pt2 (getpoint pt1 "\nPick second point of leader: "))
   (setvar "orthomode" 0)
   (setq pt3 (getpoint PT2 "\nPick third point of leader: "))
   (setq ang (angle pt3 pt2))
   (setq rot (* ang (/ 180 pi)))
   (setq pt4 (polar pt3 ang (* 0.09 (getvar "dimscale"))))
   (command ".PLINE" PT1 "W" "0" "" PT2 PT4 "W" (* 0.04 (getvar "DIMSCALE")) "0" PT3 "")
)
;;
;======================= DEGREES TO RADIANS ===============
;;
(defun dtr (a)
   (* pi (/ a 180.0))
)
;;
;======================== RADIANS TO DEGREES ==============
;;
(defun rtd (a)
   (while (>= a (* 2 pi))
      (setq a (- a (* 2 pi)))
   )
   (* a (/ 180.0 pi))
)
;;
;========================== START FUNCTION ===============
;;
(defun START_FUNC ()
   (setq clayer (getvar "clayer"))
   (setq sav_osmod (getvar "osmode"))
   (setq sav_cmde (getvar "cmdecho"))
   (setq sav_ortho (getvar "orthomode"))
   (setq sav_snap (getvar "snapmode"))
   (setvar "osmode" 0)
   (setvar "cmdecho" 0)
   (princ)
)
;;
;=========================== END FUNCTION ================ 
;;
(defun END_FUNC ()
   (setvar "cmdecho" sav_cmde)
   (setvar "osmode" sav_osmod)
   (setvar "orthomode" sav_ortho)
   (setvar "snapmode" sav_snap)
   (command ".layer" "s" clayer "")
   (princ)
)
