; TIP955.LSP:  RUNRAND.LSP   Pseudo Screen Saver Revisited
;                               (c)1994, Watson Kilbourne

;;  Modified Tip #907, (WALKRAND.LSP) CADalyst Magazine, October 1993
;;  Add internal random number generator per tip #898, September 1993
(defun c:runrand ()
   (defun rn ()
      (if (not sd) (setq sd (getvar "date")))
      (setq md 65536 mx 25173 nc 13849 sd (rem (+ (* mx sd) nc) md))
      (setq nx (/ sd md))
   )
   (grclear)
   (if (= nil OLDSEG) (setq OLDSEG 50 OLDHIS 200))
   (setq VC (getvar "viewctr")
      YD (getvar "viewsize")
      SS (getvar "screensize")
      XD (* (car SS) (/ YD (cadr SS)))
      CP (polar (polar VC pi (/ XD 2.0)) (* pi 1.5) (/ YD 2.0))
      XN (car CP)
      YN (cadr CP)
      T1 VC
      T2 VC
      LST (append (list T1) (list T2))
      COL 1
      ST 1
   )
   (initget 8)
   (setq SEG (getint (strcat "\nNumber of segments per array <"
   (rtos OLDSEG 2 0) ">: ")))
   (initget 8)
   (setq HIS (getint (strcat "\nNumber of history lines <"
   (rtos (/ OLDHIS 2) 2 0) ">: ")))
   (if (= SEG nil)(setq SEG OLDSEG))
   (if (= HIS nil)(setq HIS OLDHIS)(setq HIS (* HIS 2)))
   (setq OLDSEG SEG OLDHIS HIS)
   (while (/= ST nil)
      (setq P1 (list (+ XN (* (rn) XD)) (+ YN (* (rn) YD)))
         P2 (list (+ XN (* (rn) XD)) (+ YN (* (rn) YD)))
         D1 (/ (distance T1 P1) SEG)
         D2 (/ (distance T2 P2) SEG)
         A1 (angle T1 P1)
         A2 (angle T2 P2)
      )
      (repeat SEG
         (setq M1 (polar T1 A1 D1))
         (setq M2 (polar T2 A2 D2))
         (grdraw M1 M2 COL)
         (if (>= (length LST) HIS)
            (progn
               (setq LP1 (car LST)
                  LST (cdr LST)
                  LP2 (car LST)
                  LST (cdr LST)
               )
               (grdraw LP1 LP2 0)
            )
         )
         (setq LST (append LST (list M1) (list M2)))
         (setq T1 M1 T2 M2)
      )
      (if (= COL 7) (setq COL 1) (setq COL (+ COL 1)))
   (if (= 2 (car (grread 1 4 1))) (setq ST nil)))
   (command "redraw")
   (princ)
); end runrand.lsp
